<?php

function getch($a,&$p){
   return $a[$p++];
}
function getint1($a,&$p){
   return ord($a[$p++]);
}
function getstr($a,&$p,$len){
   $s=substr($a,$p,$len); $p+=$len; return $s;
}
function getint4($a,&$p){
   return ord($a[$p++])+(ord($a[$p++])<<8)+(ord($a[$p++])<<16)+(ord($a[$p++])<<24);
}
function getint2($a,&$p){
   return ord($a[$p++])+(ord($a[$p++])<<8);
}
function getint4mac($a,&$p){
   return (ord($a[$p++])<<24)+(ord($a[$p++])<<16)+(ord($a[$p++])<<8)+ord($a[$p++]);
}
function getint2mac($a,&$p){
   return (ord($a[$p++])<<8)+ord($a[$p++]);
}
function getint3($a,&$p){
   return ord($a[$p++])+(ord($a[$p++])<<8)+(ord($a[$p++])<<16);
}

function getzint($a,&$p){
   $n=0;
   do{
      $ch=ord($a[$p++]);
      $n=($n<<7)+($ch&0x7F);
   }while($ch&0x80);
   return $n;
}
function h2($n,$x){
   $s=dechex($n);
   while(strlen($s)<$x) $s="0".$s;
   return $s;
}
function s2($n,$x){
   $s=(string)$n;
   while(strlen($s)<$x) $s="0".$s;
   return $s;
}

function int42str($a){
   return chr($a&255).chr(($a>>8)&255).chr(($a>>16)&255).chr(($a>>24)&255);
}

function int22str($a){
   return chr($a&255).chr(($a>>8)&255);
}

function getzstr($a,&$p){
   $s="";
   do{
      $ch=$a[$p++]; if(!ord($ch)) break;
      $s.=$ch;
   }while(true);
   return $s;
}

function str2hex($s){
   $h="";
   for($i=0;$i<strlen($s);$i++){
      if($i) $h.=" ";
      $h.=h2(ord($s[$i]),2);
   }
   return $h;
}
function int4mac2str($a){
   return chr(($a>>24)&255).chr(($a>>16)&255).chr(($a>>8)&255).chr($a&255);
}
function int2mac2str($a){
   return chr(($a>>8)&255).chr($a&255);
}

function bin2float($bin){
   $u=unpack("f",$bin); return $u[1];
}
function bin2double($bin){
   $u=unpack("d",$bin); return $u[1];
}

?>